## anonsurf 4.1.0

=== Makefile ===
os_name = "$(shell cat /etc/os-release | grep "^ID=" | cut -d = -f 2)"


all: build install

clean:
	rm -rf bin

uninstall:
	# Remove config files
	rm -rf /etc/anonsurf/
	# Remove daemon scripts and some other binaries
	rm -rf /usr/lib/anonsurf/
	# Remove binaries
	rm /usr/bin/anonsurf
	rm /usr/bin/anonsurf-gtk
	# Remove systemd unit
	rm /lib/systemd/system/anonsurfd.service
	# Remove launchers
	rm /usr/share/applications/anonsurf*.desktop

build-parrot:
	# Compile binary on parrot's platform. libnim-gintro-dev is required.
	# Gintro 0.9.8 is required
	mkdir -p bin/
	nim c --nimcache:/tmp --out:bin/dnstool -d:release src/nim/dnstool/dnstool.nim
	nim c --nimcache:/tmp --out:bin/make-torrc -d:release src/nim/anonsurf/make_torrc.nim
	nim c --nimcache:/tmp --out:bin/anonsurf-gtk -p:/usr/include/nim/ -d:release src/nim/anonsurf/AnonSurfGTK.nim
	nim c --nimcache:/tmp --out:bin/anonsurf -p:/usr/include/nim/ -d:release src/nim/anonsurf/AnonSurfCli.nim

build:
	# Build on other system. nimble install gintro is required
	# Note: AnonSurf 3.3.2 was made with Gintro 0.9.6, and newer version comes with gintro 0.9.8 pre-release 
	mkdir -p bin/
	nim c --out:bin/dnstool -d:release src/nim/dnstool/dnstool.nim
	nim c --out:bin/make-torrc -d:release src/nim/anonsurf/make_torrc.nim
	nim c --out:bin/anonsurf-gtk -d:release src/nim/anonsurf/AnonSurfGTK.nim
	nim c --out:bin/anonsurf -d:release src/nim/anonsurf/AnonSurfCli.nim

install:
	# Create all folders
	mkdir -p $(DESTDIR)/etc/anonsurf/
	mkdir -p $(DESTDIR)/usr/lib/anonsurf/
	mkdir -p $(DESTDIR)/usr/bin/
	mkdir -p $(DESTDIR)/usr/share/applications/
	mkdir -p $(DESTDIR)/lib/systemd/system/

	# Copy binaries to system
	cp bin/anonsurf $(DESTDIR)/usr/bin/anonsurf
	cp bin/anonsurf-gtk $(DESTDIR)/usr/bin/anonsurf-gtk
	cp bin/dnstool $(DESTDIR)/usr/bin/dnstool
	cp bin/make-torrc $(DESTDIR)/usr/lib/anonsurf/make-torrc
	cp scripts/* $(DESTDIR)/usr/lib/anonsurf/

	# Copy launchers
	if [ os_name = "parrot" ]; then \
		cp launchers/anon-change-identity.desktop $(DESTDIR)/usr/share/applications/; \
		cp launchers/anon-surf-start.desktop $(DESTDIR)/usr/share/applications/; \
		cp launchers/anon-surf-stop.desktop $(DESTDIR)/usr/share/applications/; \
		cp launchers/anon-check-ip.desktop $(DESTDIR)/usr/share/applications/; \
		cp launchers/anon-gui.desktop $(DESTDIR)/usr/share/applications/; \
	else \
		cp launchers/non-native/*.desktop $(DESTDIR)/usr/share/applications/; \
	fi

	# Copy configs
	cp configs/bridges.txt $(DESTDIR)/etc/anonsurf/.
	cp configs/onion.pac $(DESTDIR)/etc/anonsurf/.

	# Copy daemon service
	cp sys-units/anonsurfd.service $(DESTDIR)/lib/systemd/system/anonsurfd.service

=== src/vala/Makefile ===
all:
	mkdir -p build/
	nim c -d:release --noMain --app:staticlib -o:build/anonsurf.so anonsurf_api.nim
	# valac --pkg gtk+-3.0 anonsurf_gtk.vala gui/layout_main.vala gui/layout_titlebar.vala gui/dialog_about.vala gui/layout_systray.vala gui/dialog_options.vala gui/window_anonsurf.vala -X build/anonsurf.so -X -I. -o build/anonsurf-gtk
	valac --pkg gtk+-3.0 anonsurf_gtk.vala gui/layout_main.vala gui/layout_titlebar.vala gui/dialog_about.vala gui/layout_systray.vala gui/dialog_options.vala gui/window_anonsurf.vala -X build/anonsurf.so -o build/anonsurf-gtk

=== debian/changelog ===
anonsurf (4.1.0-1mx23) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 13 Aug 2023 16:13:29 -0700

anonsurf (4.1.0+parrot0) parrot-lts; urgency=medium

  [ Nong Hoang Tu ]
  * Fixed anonsurf-gtk iat-mode regex
  * Fixed a critical bug when generate bridge mode in torrc
  * Change anonsurf-gtk to use Application. Fixed multiple systray
  * Move onionshares to suggests
  * Add Vala source code as WIP gui
 -- dmknght <dmknght@parrot>  Mon, 23 Jan 2023 14:16:02 +0700

anonsurf (4.0.0+parrot1) parrot-updates; urgency=medium

  * 4.0 release

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Sun, 21 Aug 2022 23:27:49 +0700

anonsurf (3.3.3+parrot1) parrot-updates; urgency=medium

  [ Nong Hoang Tu ]
  * Move bottom bar to header bar. Close #7
  * Use EventBox to switch from Main to Details widget
  * Remove unused objects
  * Switch to main from Details. Close #8
  * Add descriptions about Gintro version
  * Change version to 4.0.0 pre
  * Check if runResolvconf exists
  * Create type MessageCallback for callback function. It looks better than "proc" only
  * Remove old fixme which was fixed
  * Reverse the proc type for callback, which doesn't work for macro
  * Allow function check ip to be used by right click menu
  * Quit now uses the same function with core
  * Make restore main widget by left click work. Close #12
  * Remove unused comments
  * Add submenu with start / stop / restart/ status of anonsurf
  * Rewrite module main widget for better code structure
  * Change module name to ansurf_gtk_objects instead of ansurf_objects, which less confussing
  * New code structure for details widget
  * Optmize spacing between frames
  * All dialogs are no longer in folder "widgets"
  * Use same callback for menu and gui. Close #11
  * Add thank to author who wrote tutorial of systray + gtk
  * Move status to main menu
  * Swap position of about and settings
  * Status backend now shows AnonSurf not running using callback
  * Connect systray's status with backend
  * Change name "AnonSurf GUI" to "AnonSurf"
  * Create function init_main_window for window app settings
  * Merge code stack with the create Layout
  * Remove boxMainWindow show all because mainboard did this
  * Move back systray icon to main. systray icon doesn't appear when it's in child function
  * Smaller refresh boot by move update boot to other functions
  * Improve function name
  * Move all condition blocks to small functions
  * Move functions to other module
  * Move some functions to other module
  * Improve code spacing
  * Create function to update ports and services status
  * Remove trail characters
  * Remove unused libs
  * Fix wrong tag close
  * Make condition be more simple
  * Improve function name
  * Move handle refresh to refresher module
  * Imrprove name and move all refresh code to module fresher
  * Improve comment for refresh
  * Move code to make stack to other small function
  * Create a object for right click menu Item
  * remove unused comments
  * Move all backend code of menuitem to other module. Complete features
  * Update notification in makefile
  * Change callback args to enum
  * Remove comment
  * code clean
  * Improve object types
  * Code clean and close #6
  * Move module kill_apps, improve some module names
  * Add more options to settings
  * Add tooltip for bridge
  * Add option to block inbound traffic. force this feature to optional
  * New code structure
  * Move some old functions to new code
  * Add some more tmp functions
  * shorter condition by using function
  * Add button bypass network firewall to complete later
  * improve var name
  * add some hardcoded print
  * Move functions to small modules
  * More small functions
  * sightly change function structure
  * Improve condition to check dhclient's files
  * More print
  * Some more template functions
  * Improve code format
  * some more extra tmp tools
  * Add a proc to handle all dns addr
  * Filter valid addr
  * basic handle create symlink with resolvconf
  * Validate dns addr
  * Complete more functions
  * New way to handle dns addr from user
  * Remove todo
  * Complete mix with dhcp when tool can't find dhcp addr
  * Use deduplicate in write_dns_addr_to_file so it will be called by all functions
  * Make parse dhclient dns be global
  * Complete mix addr
  * Check if dns is empty before write
  * Improve dhclient code by calling pre-write functions
  * Move backup functions to util and create function to check if anonsurf is running
  * change function name to print_file_static
  * Add function to check localhost and the other features of status
  * Remove old dnstool
  * Add new dnstool to makefile build. close #9
  * Add resolvconf to suggest list
  * Improve error msg when option is invalid
  * Move check_system_dns_is_static to utils
  * Fix grammar
  * Fix wrong file to be called to parse dns addresses
  * Shorter descriptions
  * Add print function to print banner of addresses
  * Check if current system is having only localhost. Do not create backup if true
  * Add tmp function to create hook script
  * Improve code syntax
  * Create a function to do destroy dialog
  * Add some buttons to dialogs
  * Improve create backup logic check
  * Prepare objects for setting dialog
  * Move all option objects to new module
  * No longer use multiple spacing
  * Correct the symlink info to "resolvconf settings"
  * Correct the symlink info to "resolvconf settings"
  * reverse wrong commit that test text align
  * Add some basic tmp functions to handle options
  * Add a pipe object
  * Add one other function
  * Add short comment with video tutorial
  * Add more tmp functions for workflow
  * Create function to get value and set value for Config object
  * Change value type to string
  * Use default config if parser failed to load config
  * Move extOrPort to base file
  * Prepare for new option structure
  * Remove comments from old code
  * New code flow for torrc


=== debian/control ===
Source: anonsurf
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Parrot Team <team@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>,
           Lisetta "Sheireen" Ferrero <sheireen@autistiche.org>
           Nong Hoang "Dmknght" Tu <dmknght@parrotsec.org>
Standards-Version: 4.5.0
Build-Depends: bash-completion,
               debhelper-compat (= 12),
               libnim-gintro-dev,
               nim
Build-Depends-Indep: pkg-config
Homepage: https://www.parrotsec.org/

Package: anonsurf
Architecture: any
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends},
         bash (>= 5.0),
         bleachbit,
         iptables,
         libnotify4,
         nyx,
         sudo,
         systemd | systemctl,
         tor
Recommends: connect-proxy, libnotify-bin, parrot-menu, tor-geoipdb, torsocks
Suggests: gnunet, gnunet-gtk, onionshare, resolvconf, vidalia
Description: Anonymization toolkit from Parrot Security OS
 AnonSurf is an anonymization toolkit that helps
 prevent tracking and surveillance of the end-user.
 .
 AnonSurf creates a Tor transparent proxy using iptables
 to forward all traffic through the Tor network.
 It also disables IPv6 and clears application caches
 to prevent data leaks.

Package: anonsurf-gtk
Architecture: any
Priority: optional
Depends: anonsurf
Description: Graphic Interface for AnonSurf
 AnonSurf's graphic user interface and
 menu launcher written in Nim and
 gintro library (a binding of GTK framework).

Package: anonsurf-cli
Architecture: any
Priority: optional
Depends: anonsurf
Description: Command Line Interface for AnonSurf
 AnonSurf's command line interface and
 menu launcher written in Nim and
 gintro library (a binding of GTK framework).

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with bash-completion
# override_dh_auto_configure:
# 	nimble install gintro
override_dh_installsystemd:
	dh_installsystemd --no-enable
override_dh_auto_build:
	make build-parrot
override_dh_auto_install:
# Install apparmor
# Learned from Tor rule
# override_dh_install-arch:
# 	dh_apparmor --profile-name=usr.bin.anonsurf -panonsurf

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

## anonsurf 5.0.0+parrot1

=== Makefile ===
VALA-FLAGS = --pkg gtk+-3.0 # GTK3
VALA-FLAGS += --pkg libsoup-2.4 # Use libsoup to parse HTML, build-time requires libsoup2.4-dev
VALA-FLAGS += --pkg libnotify # Use libnotify to send notifications, build-time requires libnotify-dev
VALA-FLAGS += --vapidir /usr/share/vala/vapi/ --pkg vte-2.91 # Use libvte to create a terminal. build-time requires libvte-2.91-dev. Libvte binding is at /usr/share/vala/vapi/vte-2.91.vapi
VALA-FLAGS += -X -Wno-incompatible-pointer-types # Suppress Vala's warning. Check https://stackoverflow.com/a/66559047
VALA-FLAGS += -X -Wno-discarded-qualifiers # Supress Vala's warning. Check https://stackoverflow.com/a/66559047

VALA-SRC-DIR = src/anonsurf-gtk
VALA-SRC-LAYOUTS = $(VALA-SRC-DIR)/layouts
VALA-SRC-DIALOGS = $(VALA-SRC-DIR)/dialogs
VALA-SRC-SYS = $(VALA-SRC-DIR)/system_interactions

NIM-FLAGS = c --nimcache:/tmp/ -d:ssl -d:release
BUILD-DEST = build/release

os_name="$(shell cat /etc/os-release | grep "^ID=" | cut -d = -f 2)"

.PHONY: build

all: build install

clean:
	rm -rf build

anonsurf-gtk:
	valac $(VALA-FLAGS) $(VALA-SRC-DIR)/anonsurf_gtk.vala \
	$(VALA-SRC-LAYOUTS)/box_boot.vala $(VALA-SRC-LAYOUTS)/box_controller.vala $(VALA-SRC-LAYOUTS)/titlebar.vala \
	$(VALA-SRC-DIALOGS)/about.vala $(VALA-SRC-DIALOGS)/tor_controller.vala $(VALA-SRC-DIALOGS)/ask_kill.vala \
	$(VALA-SRC-SYS)/notifications.vala $(VALA-SRC-SYS)/system_tray_icon.vala $(VALA-SRC-SYS)/system_tray_menu.vala $(VALA-SRC-SYS)/threads.vala \
	-o $(BUILD-DEST)/anonsurf-gtk

anonsurf-cli:
	nim $(NIM-FLAGS) --out:$(BUILD-DEST)/anonsurf src/anonsurf_cli/anonsurf_cli.nim

dnstool:
	nim $(NIM-FLAGS) --out:$(BUILD-DEST)/dnstool src/dnstool/dnstool.nim

make-torrc:
	nim $(NIM-FLAGS) --out:$(BUILD-DEST)/make-torrc src/make_torrc/make_torrc.nim

build: anonsurf-cli anonsurf-gtk dnstool make-torrc

inst-launchers:
	# Copy launchers
	if [ $(os_name) = "parrot" ]; then \
		cp launchers/parrot/*.desktop $(DESTDIR)/usr/share/applications/; \
	else \
		cp launchers/debian/*.desktop $(DESTDIR)/usr/share/applications/; \
	fi

inst-configs:
	# Copy configs
	cp configs/bridges.txt $(DESTDIR)/etc/anonsurf/.
	cp configs/onion.pac $(DESTDIR)/etc/anonsurf/.
	cp configs/anonsurf.cfg $(DESTDIR)/etc/anonsurf/.

	# Copy daemon service
	cp sys-units/anonsurfd.service $(DESTDIR)/lib/systemd/system/anonsurfd.service

inst-bins:
	# Copy binaries to system
	cp build/release/anonsurf $(DESTDIR)/usr/bin/anonsurf
	cp build/release/anonsurf-gtk $(DESTDIR)/usr/bin/anonsurf-gtk
	cp build/release/dnstool $(DESTDIR)/usr/bin/dnstool
	cp build/release/make-torrc $(DESTDIR)/usr/lib/anonsurf/make-torrc
	cp scripts/* $(DESTDIR)/usr/lib/anonsurf/

inst-perms:
	chmod +x $(DESTDIR)/usr/lib/anonsurf/make-torrc $(DESTDIR)/usr/lib/anonsurf/safekill $(DESTDIR)/usr/bin/anonsurf $(DESTDIR)/usr/bin/anonsurf-gtk

inst-icons:
	cp icons/*.png $(DESTDIR)/usr/share/icons/.

mk-folders:
	# Create all folders
	mkdir -p $(DESTDIR)/etc/anonsurf/
	mkdir -p $(DESTDIR)/usr/lib/anonsurf/
	mkdir -p $(DESTDIR)/usr/bin/
	mkdir -p $(DESTDIR)/usr/share/applications/
	mkdir -p $(DESTDIR)/lib/systemd/system/

install: mk-folders inst-bins inst-configs inst-launchers inst-icons inst-perms

uninstall:
	# Remove config files
	rm -rf /etc/anonsurf/
	# Remove daemon scripts and some other binaries
	rm -rf /usr/lib/anonsurf/
	# Remove binaries
	rm /usr/bin/anonsurf
	rm /usr/bin/anonsurf-gtk
	# Remove systemd unit
	rm /lib/systemd/system/anonsurfd.service
	# Remove launchers
	rm /usr/share/applications/anonsurf*.desktop

=== debian/changelog ===
anonsurf (5.0.0+parrot1) lory; urgency=medium

  * Release version 5.0

 -- dmknght <dmknght@parrotsec.org>  Wed, 10 Jun 2024 15:59:34 +0700

anonsurf (4.1.1+parrot2) lory; urgency=medium

  * Rebuild for Parrot 6.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Tue, 19 Dec 2023 09:54:15 +0100

anonsurf (4.1.1+parrot1) parrot-lts; urgency=medium

  * Fix version name for stable release

 -- dmknght <dmknght@parrotsec.org>  Thu, 02 Feb 2023 15:59:34 +0700

=== debian/control ===
Source: anonsurf
Section: net
Priority: optional
Maintainer: Parrot Team <team@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>,
           Lisetta "Sheireen" Ferrero <sheireen@autistiche.org>
           Nong Hoang "Dmknght" Tu <dmknght@parrotsec.org>
Standards-Version: 4.5.0
Build-Depends:
 debhelper-compat (= 12),
 nim,
 gcc (>= 10),
 bash-completion,
 valac,
 libsoup2.4-dev,
 libnotify-dev,
 libvte-2.91-dev,
Build-Depends-Indep: pkg-config
Homepage: https://www.parrotsec.org/

Package: anonsurf
Architecture: any
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, bash (>= 5.0), iptables, tor, systemd | systemctl, sudo
Recommends: tor-geoipdb, parrot-menu
Suggests: gnunet-gtk, gnunet, vidalia, resolvconf, onionshare, connect-proxy, bleachbit, snowflake-client, obfs4proxy
Description: Anonymization toolkit for Parrot Security OS
 AnonSurf is an anonymization toolkit that helps
 prevent tracking and surveillance of the end-user.
 .
 AnonSurf creates a Tor transparent proxy using iptables
 to forward all traffic through the Tor network.
 It also disables IPv6 and clears application caches
 to prevent data leaks.

Package: anonsurf-gtk
Architecture: any
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, anonsurf, nyx, pkexec
Recommends: parrot-menu
Description: Graphic Interface for AnonSurf
 AnonSurf's graphic user interface and
 menu launcher written in Vala

Package: anonsurf-cli
Architecture: any
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, anonsurf, nyx, sudo
Description: Command Line Interfaced for AnonSurf
 AnonSurf's command line interface and
 menu launcher written in Nim

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with bash-completion

override_dh_installsystemd:
	dh_installsystemd --no-enable
override_dh_auto_build:
	make build

override_dh_fixperms:
	chmod +x debian/anonsurf/usr/lib/anonsurf/safekill

override_dh_auto_install:
